//+------------------------------------------------------------------+
//|                                               PowerTrend-T01.mq4 |
//|                          Copyright  2007, HomeSoft-Tartan Corp. |
//|                                              spiky@transkeino.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, HomeSoft-Tartan Corp."
#property link      "spiky@transkeino.ru"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red

extern double    b = 0.7; 
extern int     t3p = 21;
extern int     mBar = 300; 
extern string   add = "www.fxexpert.ru";
extern string autor = "Tartan"; 

//---- buffers
double ExtMapBuffer1[],ExtMapBuffer2[],rpo,rpn,top,histo,t3,t3old;
double e1,e2,e3,e4,e5,e6,c1,c2,c3,c4,n,w1,w2,b2,b3;
int    shift,per,pr;
bool   ft = true;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM,0,3,Lime);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,3,Red);
   SetIndexBuffer(1,ExtMapBuffer2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//   int    counted_bars=IndicatorCounted();
//----

if (ft)
 {
    b2=b*b;
    b3=b2*b;
    c1=-b3;
    c2=(3*(b2+b3));
    c3=-3*(2*b2+b+b3);
    c4=(1+3*b+b3+3*b2);
    n=t3p;
if (n<1) n=1;
    n =1 + 0.5*(n-1);
    w1=2/(n + 1);
    w2=1-w1;
    
if (Point>0.0002) pr=2; else pr=4;
 }

    per=MathRound((24*60)/Period());

for(shift=mBar;shift>=0;shift--)
 {
    rpn=iCustom(NULL,0,"RoundPriceExp",t3p,b,mBar,0,shift);
    rpo=iCustom(NULL,0,"RoundPriceExp",t3p,b,mBar,0,shift+1);
    top=Close[shift+1];
    histo=MathRound((Close[shift]-rpn)/Point);
    t3old=t3;
    e1 = w1*histo + w2*e1;
    e2 = w1*e1 + w2*e2;
    e3 = w1*e2 + w2*e3;
    e4 = w1*e3 + w2*e4;
    e5 = w1*e4 + w2*e5;
    e6 = w1*e5 + w2*e6;
    
    t3 = c1*e6 + c2*e5 + c3*e4 + c4*e3;
 if(t3>t3old) {ExtMapBuffer1[shift]=t3;ExtMapBuffer2[shift]=0;}
 if(t3old>t3) {ExtMapBuffer2[shift]=t3;ExtMapBuffer1[shift]=0;}
 }
//----
   return(0);
  }
//+------------------------------------------------------------------+